### Airway Obstruction

The airway obstruction action was validated with a scenario that applies varying severities of 0.3, 0.6, and 1.0. Varying the severity of the obstruction simulates partial obstructions and a complete obstruction. The severity levels logarithmically increase the airway resistance. The resulting outputs from the engine are shown for each severity in the tables below for common clinical parameters.

@htmlonly
<center>
<table border="0">
<tr>
    <td><a href="./plots/Respiratory/AirwayObstruction_TidalVolume.jpg"><img src="./plots/Respiratory/AirwayObstruction_TidalVolume.jpg" width="550"></a></td>
    <td><a href="./plots/Respiratory/AirwayObstruction_CO2PP.jpg"><img src="./plots/Respiratory/AirwayObstruction_CO2PP.jpg" width="550"></a></td>
</tr>
<tr>
    <td><a href="./plots/Respiratory/AirwayObstruction_O2Sat.jpg"><img src="./plots/Respiratory/AirwayObstruction_O2Sat.jpg" width="550"></a></td>
    <td><a href="/plots/Respiratory/AirwayObstruction_MAP.jpg"><img src="./plots/Respiratory/AirwayObstruction_MAP.jpg" width="550"></a></td>
</tr>
<tr>
    <td colspan="2"><a href="./plots/Respiratory/AirwayObstructionLegend.jpg"><img src="./plots/Respiratory/AirwayObstructionLegend.jpg" width="1100"></a></td>
</tr>
</table>
<br>
</center>
@endhtmlonly
<center>
*@figuredef {AirwayObstructionVariedOutputs}. Select outputs from the airway obstruction scenario.*
</center><br>

#### Segment 1

@insert ./validation/tables/AirwayObstruction/Varied/Segment1ValidationTable.md

#### Segment 2

@insert ./validation/tables/AirwayObstruction/Varied/Segment2ValidationTable.md

#### Segment 3

@insert ./validation/tables/AirwayObstruction/Varied/Segment3ValidationTable.md

#### Segment 4

@insert ./validation/tables/AirwayObstruction/Varied/Segment4ValidationTable.md

#### Segment 5

@insert ./validation/tables/AirwayObstruction/Varied/Segment5ValidationTable.md

#### Segment 6

@insert ./validation/tables/AirwayObstruction/Varied/Segment6ValidationTable.md
