
set(CDM_H_FILES
  cdm/CommonDefs.h
  cdm/Doxy.h
  cdm/Macros.h
  cdm/PhysiologyEngine.h
  cdm/PhysiologyEngineThunk.h
  cdm/PhysiologyEnginePool.h
  cdm/blackbox/SEBlackBox.h
  cdm/blackbox/SEBlackBox.hxx
  cdm/blackbox/SEBlackBoxManager.h
  cdm/blackbox/electrical/SEElectricalBlackBox.h
  cdm/blackbox/fluid/SEFluidBlackBox.h
  cdm/blackbox/fluid/SEGasBlackBox.h
  cdm/blackbox/fluid/SELiquidBlackBox.h
  cdm/blackbox/thermal/SEThermalBlackBox.h
  cdm/circuit/SECircuit.h
  cdm/circuit/SECircuit.hxx
  cdm/circuit/SECircuitCalculator.h  
  cdm/circuit/SECircuitManager.h
  cdm/circuit/SECircuitManager.hxx
  cdm/circuit/SECircuitNode.h
  cdm/circuit/SECircuitNode.hxx
  cdm/circuit/SECircuitPath.h
  cdm/circuit/SECircuitPath.hxx
  cdm/circuit/electrical/SEElectricalCircuit.h
  cdm/circuit/electrical/SEElectricalCircuitCalculator.h
  cdm/circuit/electrical/SEElectricalCircuitNode.h
  cdm/circuit/electrical/SEElectricalCircuitPath.h
  cdm/circuit/fluid/SEFluidCircuit.h
  cdm/circuit/fluid/SEFluidCircuitCalculator.h
  cdm/circuit/fluid/SEFluidCircuitNode.h
  cdm/circuit/fluid/SEFluidCircuitPath.h
  cdm/circuit/thermal/SEThermalCircuit.h
  cdm/circuit/thermal/SEThermalCircuitCalculator.h
  cdm/circuit/thermal/SEThermalCircuitNode.h
  cdm/circuit/thermal/SEThermalCircuitPath.h
  cdm/compartment/SECompartment.h
  cdm/compartment/SECompartmentGraph.h
  cdm/compartment/SECompartmentGraph.hxx
  cdm/compartment/SECompartmentLink.h
  cdm/compartment/SECompartmentManager.h
  cdm/compartment/SECompartmentNodes.h
  cdm/compartment/SECompartmentNodes.hxx
  cdm/compartment/SECompartmentTransportGraph.h
  cdm/compartment/SECompartmentTransportGraph.hxx
  cdm/compartment/electrical/SEElectricalCompartment.h
  cdm/compartment/electrical/SEElectricalCompartmentLink.h
  cdm/compartment/fluid/SEFluidCompartment.h  
  cdm/compartment/fluid/SEFluidCompartment.hxx
  cdm/compartment/fluid/SEFluidCompartmentLink.h
  cdm/compartment/fluid/SEFluidCompartmentLink.hxx
  cdm/compartment/fluid/SEGasCompartment.h
  cdm/compartment/fluid/SEGasCompartmentGraph.h
  cdm/compartment/fluid/SEGasCompartmentLink.h
  cdm/compartment/fluid/SELiquidCompartment.h
  cdm/compartment/fluid/SELiquidCompartmentGraph.h
  cdm/compartment/fluid/SELiquidCompartmentLink.h
  cdm/compartment/substances/SEGasSubstanceQuantity.h
  cdm/compartment/substances/SELiquidSubstanceQuantity.h
  cdm/compartment/substances/SESubstanceQuantity.h
  cdm/compartment/thermal/SEThermalCompartment.h
  cdm/compartment/thermal/SEThermalCompartmentLink.h
  cdm/compartment/tissue/SETissueCompartment.h
  cdm/engine/SEAction.h
  cdm/engine/SEActionManager.h
  cdm/engine/SEAdvanceHandler.h
  cdm/engine/SEAdvanceTime.h
  cdm/engine/SEAdvanceUntilStable.h
  cdm/engine/SECondition.h
  cdm/engine/SEConditionManager.h
  cdm/engine/SEDataRequest.h
  cdm/engine/SEDataRequested.h
  cdm/engine/SEDataRequestManager.h
  cdm/engine/SEDecimalFormat.h
  cdm/engine/SEDynamicStabilization.h
  cdm/engine/SEDynamicStabilizationEngineConvergence.h
  cdm/engine/SEDynamicStabilizationLedger.h
  cdm/engine/SEDynamicStabilizationPropertyConvergence.h
  cdm/engine/SEEngineConfiguration.h
  cdm/engine/SEEngineInitialization.h
  cdm/engine/SEEngineStabilization.h
  cdm/engine/SEEngineTracker.h
  cdm/engine/SEEnvironmentActionCollection.h
  cdm/engine/SEEquipmentActionCollection.h
  cdm/engine/SEEventManager.h
  cdm/engine/SEOverrides.h
  cdm/engine/SEPatientActionCollection.h
  cdm/engine/SEPatientConfiguration.h
  cdm/engine/SESerializeRequested.h
  cdm/engine/SESerializeState.h
  cdm/engine/SETimedStabilization.h
  cdm/engine/SEValidationTarget.h
  cdm/io/protobuf/PBActions.h
  cdm/io/protobuf/PBAnesthesiaMachine.h
  cdm/io/protobuf/PBBagValveMask.h
  cdm/io/protobuf/PBBlackBox.h
  cdm/io/protobuf/PBCircuit.h
  cdm/io/protobuf/PBCompartment.h
  cdm/io/protobuf/PBConditions.h
  cdm/io/protobuf/PBECMO.h
  cdm/io/protobuf/PBElectroCardioGram.h
  cdm/io/protobuf/PBEngine.h
  cdm/io/protobuf/PBEnvironment.h
  cdm/io/protobuf/PBEnvironmentActions.h
  cdm/io/protobuf/PBEnvironmentConditions.h
  cdm/io/protobuf/PBEquipmentActions.h
  cdm/io/protobuf/PBEvents.h
  cdm/io/protobuf/PBInhaler.h
  cdm/io/protobuf/PBMechanicalVentilator.h
  cdm/io/protobuf/PBPatient.h
  cdm/io/protobuf/PBPatientActions.h
  cdm/io/protobuf/PBPatientAssessments.h
  cdm/io/protobuf/PBPatientConditions.h
  cdm/io/protobuf/PBPatientNutrition.h
  cdm/io/protobuf/PBPhysiology.h
  cdm/io/protobuf/PBProperties.h
  cdm/io/protobuf/PBScenario.h
  cdm/io/protobuf/PBSubstance.h
  cdm/io/protobuf/PBSubstanceQuantity.h
  cdm/io/protobuf/PBTestReport.h
  cdm/io/protobuf/PBUtils.h
  cdm/io/protobuf/PBValidation.h
  cdm/patient/SEMeal.h
  cdm/patient/SENutrition.h
  cdm/patient/SEPatient.h
  cdm/patient/actions/SEAcuteRespiratoryDistressSyndromeExacerbation.h
  cdm/patient/actions/SEAcuteStress.h
  cdm/patient/actions/SEAirwayObstruction.h
  cdm/patient/actions/SEArrhythmia.h
  cdm/patient/actions/SEAsthmaAttack.h
  cdm/patient/actions/SEBrainInjury.h
  cdm/patient/actions/SEBronchoconstriction.h
  cdm/patient/actions/SECardiovascularMechanicsModification.h
  cdm/patient/actions/SEChestCompression.h
  cdm/patient/actions/SEChestCompressionAutomated.h
  cdm/patient/actions/SEChestCompressionInstantaneous.h
  cdm/patient/actions/SEChestOcclusiveDressing.h
  cdm/patient/actions/SEChronicObstructivePulmonaryDiseaseExacerbation.h
  cdm/patient/actions/SEConsciousRespiration.h
  cdm/patient/actions/SEConsciousRespirationCommand.h
  cdm/patient/actions/SEConsumeNutrients.h
  cdm/patient/actions/SEDyspnea.h
  cdm/patient/actions/SEExercise.h
  cdm/patient/actions/SEForcedExhale.h
  cdm/patient/actions/SEForcedInhale.h
  cdm/patient/actions/SEForcedPause.h
  cdm/patient/actions/SEHemorrhage.h
  cdm/patient/actions/SEHemothorax.h
  cdm/patient/actions/SEImpairedAlveolarExchangeExacerbation.h
  cdm/patient/actions/SEIntubation.h
  cdm/patient/actions/SEMechanicalVentilation.h
  cdm/patient/actions/SENeedleDecompression.h
  cdm/patient/actions/SEPatientAction.h
  cdm/patient/actions/SEPatientAssessmentRequest.h
  cdm/patient/actions/SEPericardialEffusion.h
  cdm/patient/actions/SEPneumoniaExacerbation.h
  cdm/patient/actions/SEPulmonaryShuntExacerbation.h
  cdm/patient/actions/SERespiratoryFatigue.h
  cdm/patient/actions/SERespiratoryMechanicsConfiguration.h
  cdm/patient/actions/SERespiratoryMechanicsModification.h
  cdm/patient/actions/SESubstanceAdministration.h
  cdm/patient/actions/SESubstanceBolus.h
  cdm/patient/actions/SESubstanceCompoundInfusion.h
  cdm/patient/actions/SESubstanceInfusion.h
  cdm/patient/actions/SESupplementalOxygen.h
  cdm/patient/actions/SETensionPneumothorax.h
  cdm/patient/actions/SETubeThoracostomy.h
  cdm/patient/actions/SEUrinate.h
  cdm/patient/actions/SEUseInhaler.h
  cdm/patient/assessments/SEArterialBloodGasTest.h
  cdm/patient/assessments/SECompleteBloodCount.h
  cdm/patient/assessments/SEComprehensiveMetabolicPanel.h
  cdm/patient/assessments/SEPatientAssessment.h
  cdm/patient/assessments/SEUrinalysis.h
  cdm/patient/assessments/SEUrinalysisMicroscopic.h
  cdm/patient/conditions/SEAcuteRespiratoryDistressSyndrome.h
  cdm/patient/conditions/SEChronicAnemia.h
  cdm/patient/conditions/SEChronicObstructivePulmonaryDisease.h
  cdm/patient/conditions/SEChronicPericardialEffusion.h
  cdm/patient/conditions/SEChronicRenalStenosis.h
  cdm/patient/conditions/SEChronicVentricularSystolicDysfunction.h
  cdm/patient/conditions/SEConsumeMeal.h
  cdm/patient/conditions/SEDehydration.h
  cdm/patient/conditions/SEImpairedAlveolarExchange.h
  cdm/patient/conditions/SEPatientCondition.h
  cdm/patient/conditions/SEPneumonia.h
  cdm/patient/conditions/SEPulmonaryFibrosis.h
  cdm/patient/conditions/SEPulmonaryShunt.h
  cdm/patient/conditions/SESepsis.h
  cdm/properties/SEArray.h
  cdm/properties/SEArrayElectricPotential.h
  #cdm/properties/SEArrayPressure.h
  #cdm/properties/SEArrayVolume.h
  #cdm/properties/SEArrayVolumePerTime.h
  cdm/properties/SECurve.h
  cdm/properties/SEFunction.h
  cdm/properties/SEFunctionElectricPotentialVsTime.h
  cdm/properties/SEFunctionVolumeVsTime.h
  cdm/properties/SEHistogram.h
  cdm/properties/SEHistogramFractionVsLength.h
  cdm/properties/SEProperty.h
  cdm/properties/SERunningAverage.h
  cdm/properties/SESegment.h
  cdm/properties/SESegmentConstant.h
  cdm/properties/SESegmentLinear.h
  cdm/properties/SESegmentParabolic.h
  cdm/properties/SESegmentSigmoidal.h
  cdm/properties/SEScalar.h
  cdm/properties/SEScalar.hxx
  cdm/properties/SEScalar0To1.h
  cdm/properties/SEScalarAmount.h
  cdm/properties/SEScalarAmountPerMass.h
  cdm/properties/SEScalarAmountPerTime.h
  cdm/properties/SEScalarAmountPerVolume.h
  cdm/properties/SEScalarArea.h
  cdm/properties/SEScalarAreaPerTimePressure.h
  cdm/properties/SEScalarElectricCapacitance.h
  cdm/properties/SEScalarElectricCharge.h
  cdm/properties/SEScalarElectricCurrent.h
  cdm/properties/SEScalarElectricInductance.h
  cdm/properties/SEScalarElectricPotential.h
  cdm/properties/SEScalarElectricResistance.h
  cdm/properties/SEScalarEnergy.h
  cdm/properties/SEScalarEnergyPerAmount.h
  cdm/properties/SEScalarEnergyPerMass.h
  cdm/properties/SEScalarEquivalentWeightPerVolume.h
  cdm/properties/SEScalarForce.h
  cdm/properties/SEScalarFrequency.h
  cdm/properties/SEScalarHeatCapacitance.h
  cdm/properties/SEScalarHeatCapacitancePerAmount.h
  cdm/properties/SEScalarHeatCapacitancePerMass.h
  cdm/properties/SEScalarHeatConductance.h
  cdm/properties/SEScalarHeatConductancePerArea.h
  cdm/properties/SEScalarHeatInductance.h
  cdm/properties/SEScalarHeatResistance.h
  cdm/properties/SEScalarHeatResistanceArea.h
  cdm/properties/SEScalarInversePressure.h
  cdm/properties/SEScalarInverseVolume.h
  cdm/properties/SEScalarLength.h
  cdm/properties/SEScalarLengthPerTime.h
  cdm/properties/SEScalarLengthPerTimePressure.h
  cdm/properties/SEScalarMass.h
  cdm/properties/SEScalarMassPerAmount.h
  cdm/properties/SEScalarMassPerAreaTime.h
  cdm/properties/SEScalarMassPerMass.h
  cdm/properties/SEScalarMassPerTime.h
  cdm/properties/SEScalarMassPerVolume.h
  cdm/properties/SEScalarNegative1To1.h
  cdm/properties/SEScalarOsmolality.h
  cdm/properties/SEScalarOsmolarity.h
  cdm/properties/SEScalarPower.h
  cdm/properties/SEScalarPowerPerAreaTemperatureToTheFourth.h
  cdm/properties/SEScalarPressure.h
  cdm/properties/SEScalarPressurePerVolume.h
  cdm/properties/SEScalarPressureTimePerArea.h
  cdm/properties/SEScalarPressureTimePerVolume.h
  cdm/properties/SEScalarPressureTimePerVolumeArea.h
  cdm/properties/SEScalarPressureTimeSquaredPerVolume.h
  cdm/properties/SEScalarTemperature.h
  cdm/properties/SEScalarTime.h
  cdm/properties/SEScalarUnsigned.h
  cdm/properties/SEScalarVolume.h
  cdm/properties/SEScalarVolumePerPressure.h
  cdm/properties/SEScalarVolumePerTime.h
  cdm/properties/SEScalarVolumePerTimeArea.h
  cdm/properties/SEScalarVolumePerTimeMass.h
  cdm/properties/SEScalarVolumePerTimePressure.h
  cdm/properties/SEScalarVolumePerTimePressureArea.h
  cdm/properties/SETemporalInterpolator.h
  cdm/scenario/SEScenario.h
  cdm/scenario/SEScenarioExec.h
  cdm/scenario/SEScenarioLog.h
  cdm/substance/SESubstance.h
  cdm/substance/SESubstanceAerosolization.h
  cdm/substance/SESubstanceClearance.h
  cdm/substance/SESubstanceCompound.h
  cdm/substance/SESubstanceConcentration.h
  cdm/substance/SESubstanceFraction.h
  cdm/substance/SESubstanceManager.h
  cdm/substance/SESubstancePharmacodynamics.h
  cdm/substance/SESubstancePharmacokinetics.h
  cdm/substance/SESubstancePhysicochemicals.h
  cdm/substance/SESubstanceTissuePharmacokinetics.h
  cdm/substance/SESubstanceTransport.h
  cdm/system/SESystem.h
  cdm/system/environment/SEActiveConditioning.h
  cdm/system/environment/SEAppliedTemperature.h
  cdm/system/environment/SEEnvironment.h
  cdm/system/environment/SEEnvironmentalConditions.h
  cdm/system/environment/actions/SEChangeEnvironmentalConditions.h
  cdm/system/environment/actions/SEEnvironmentAction.h
  cdm/system/environment/actions/SEThermalApplication.h
  cdm/system/environment/conditions/SEEnvironmentCondition.h
  cdm/system/environment/conditions/SEInitialEnvironmentalConditions.h
  cdm/system/equipment/SEEquipment.h
  cdm/system/equipment/SEEquipmentAction.h
  cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachine.h
  cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachineChamber.h
  cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachineOxygenBottle.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineAction.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineConfiguration.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineExpiratoryValveLeak.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineExpiratoryValveObstruction.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineInspiratoryValveLeak.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineInspiratoryValveObstruction.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineMaskLeak.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineOxygenTankPressureLoss.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineOxygenWallPortPressureLoss.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineSodaLimeFailure.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineTubeCuffLeak.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineVaporizerFailure.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineVentilatorPressureLoss.h
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineYPieceDisconnect.h
  cdm/system/equipment/bag_valve_mask/SEBagValveMask.h
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskAction.h
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskAutomated.h
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskConfiguration.h
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskInstantaneous.h
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskSqueeze.h
  cdm/system/equipment/ecmo/SEECMO.h
  cdm/system/equipment/ecmo/SEECMOSettings.h
  cdm/system/equipment/ecmo/actions/SEECMOAction.h
  cdm/system/equipment/ecmo/actions/SEECMOConfiguration.h
  cdm/system/equipment/electrocardiogram/SEElectroCardioGram.h
  cdm/system/equipment/electrocardiogram/SEElectroCardioGramWaveform.h
  cdm/system/equipment/inhaler/SEInhaler.h
  cdm/system/equipment/inhaler/actions/SEInhalerAction.h
  cdm/system/equipment/inhaler/actions/SEInhalerConfiguration.h
  cdm/system/equipment/mechanical_ventilator/SEMechanicalVentilator.h
  cdm/system/equipment/mechanical_ventilator/SEMechanicalVentilatorSettings.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorAction.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorConfiguration.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorContinuousPositiveAirwayPressure.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorHold.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorLeak.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorMode.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorPressureControl.h
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorVolumeControl.h
  cdm/system/physiology/SEBloodChemistrySystem.h
  cdm/system/physiology/SECardiovascularSystem.h
  cdm/system/physiology/SECardiovascularMechanicsModifiers.h
  cdm/system/physiology/SEDrugSystem.h
  cdm/system/physiology/SEEndocrineSystem.h
  cdm/system/physiology/SEEnergySystem.h
  cdm/system/physiology/SEGastrointestinalSystem.h
  cdm/system/physiology/SEHepaticSystem.h
  cdm/system/physiology/SENervousSystem.h
  cdm/system/physiology/SEPupillaryResponse.h
  cdm/system/physiology/SERenalSystem.h
  cdm/system/physiology/SERespiratoryMechanics.h
  cdm/system/physiology/SERespiratoryMechanicsModifiers.h
  cdm/system/physiology/SERespiratorySystem.h
  cdm/system/physiology/SETissueSystem.h
  cdm/utils/ConfigParser.h
  cdm/utils/CSV.h
  cdm/utils/DataPeak.h
  cdm/utils/DataTrack.h
  cdm/utils/EnumHashSpecialization.h
  cdm/utils/FileUtils.h
  cdm/utils/GeneralMath.h
  cdm/utils/Logger.h
  cdm/utils/ParameterIteration.h
  cdm/utils/ScopedMutex.h
  cdm/utils/SmartEnum.h
  cdm/utils/TimingProfile.h
  cdm/utils/ThreadPool.h
  cdm/utils/base64.h
  cdm/utils/testing/SETestCase.h
  cdm/utils/testing/SETestErrorStatistics.h
  cdm/utils/testing/SETestManager.h
  cdm/utils/testing/SETestReport.h
  cdm/utils/testing/SETestSuite.h
  cdm/utils/unitconversion/CompoundUnit.h
  cdm/utils/unitconversion/CompoundUnitElement.h
  cdm/utils/unitconversion/PScalar.h
  cdm/utils/unitconversion/PrefixDescriptor.h
  cdm/utils/unitconversion/QuantityConversionDescriptor.h
  cdm/utils/unitconversion/QuantityConversionKey.h
  cdm/utils/unitconversion/QuantityTypeDescriptor.h
  cdm/utils/unitconversion/SnapValue.h
  cdm/utils/unitconversion/UCCommon.h
  cdm/utils/unitconversion/UnitConversionEngine.h
  cdm/utils/unitconversion/UnitDescriptor.h
  cdm/utils/unitconversion/UnitDimension.h
  cdm/utils/unitconversion/UnitStringLexer.h
)
set(CDM_CPP_FILES
  cdm/PhysiologyEngineThunk.cpp
  cdm/PhysiologyEnginePool.cpp
  cdm/blackbox/SEBlackBoxManager.cpp
  cdm/blackbox/electrical/SEElectricalBlackBox.cpp
  cdm/blackbox/fluid/SEFluidBlackBox.cpp
  cdm/blackbox/fluid/SEGasBlackBox.cpp
  cdm/blackbox/fluid/SELiquidBlackBox.cpp
  cdm/blackbox/thermal/SEThermalBlackBox.cpp
  cdm/circuit/SECircuitCalculator.cpp
  cdm/circuit/SECircuitManager.cpp
  cdm/circuit/electrical/SEElectricalCircuit.cpp
  cdm/circuit/electrical/SEElectricalCircuitCalculator.cpp
  cdm/circuit/electrical/SEElectricalCircuitNode.cpp
  cdm/circuit/electrical/SEElectricalCircuitPath.cpp
  cdm/circuit/fluid/SEFluidCircuit.cpp
  cdm/circuit/fluid/SEFluidCircuitCalculator.cpp
  cdm/circuit/fluid/SEFluidCircuitNode.cpp
  cdm/circuit/fluid/SEFluidCircuitPath.cpp
  cdm/circuit/thermal/SEThermalCircuit.cpp
  cdm/circuit/thermal/SEThermalCircuitCalculator.cpp
  cdm/circuit/thermal/SEThermalCircuitNode.cpp
  cdm/circuit/thermal/SEThermalCircuitPath.cpp
  cdm/compartment/SECompartment.cpp
  cdm/compartment/SECompartmentLink.cpp
  cdm/compartment/SECompartmentManager.cpp
  cdm/compartment/electrical/SEElectricalCompartment.cpp
  cdm/compartment/electrical/SEElectricalCompartmentLink.cpp
  cdm/compartment/fluid/SEGasCompartment.cpp
  cdm/compartment/fluid/SEGasCompartmentGraph.cpp
  cdm/compartment/fluid/SEGasCompartmentLink.cpp
  cdm/compartment/fluid/SELiquidCompartment.cpp
  cdm/compartment/fluid/SELiquidCompartmentGraph.cpp
  cdm/compartment/fluid/SELiquidCompartmentLink.cpp
  cdm/compartment/substances/SEGasSubstanceQuantity.cpp
  cdm/compartment/substances/SELiquidSubstanceQuantity.cpp
  cdm/compartment/substances/SESubstanceQuantity.cpp
  cdm/compartment/thermal/SEThermalCompartment.cpp
  cdm/compartment/thermal/SEThermalCompartmentLink.cpp
  cdm/compartment/tissue/SETissueCompartment.cpp
  cdm/engine/SEAction.cpp
  cdm/engine/SEActionManager.cpp
  cdm/engine/SEAdvanceTime.cpp
  cdm/engine/SEAdvanceUntilStable.cpp
  cdm/engine/SECondition.cpp
  cdm/engine/SEConditionManager.cpp
  cdm/engine/SEDataRequest.cpp
  cdm/engine/SEDataRequested.cpp
  cdm/engine/SEDataRequestManager.cpp
  cdm/engine/SEDecimalFormat.cpp
  cdm/engine/SEDynamicStabilization.cpp
  cdm/engine/SEDynamicStabilizationEngineConvergence.cpp
  cdm/engine/SEDynamicStabilizationLedger.cpp
  cdm/engine/SEDynamicStabilizationPropertyConvergence.cpp
  cdm/engine/SEEngineInitialization.cpp
  cdm/engine/SEEngineStabilization.cpp
  cdm/engine/SEEngineTracker.cpp
  cdm/engine/SEEnvironmentActionCollection.cpp
  cdm/engine/SEEquipmentActionCollection.cpp
  cdm/engine/SEEventManager.cpp
  cdm/engine/SEOverrides.cpp
  cdm/engine/SEPatientActionCollection.cpp
  cdm/engine/SEPatientConfiguration.cpp
  cdm/engine/SESerializeRequested.cpp
  cdm/engine/SESerializeState.cpp
  cdm/engine/SETimedStabilization.cpp
  cdm/engine/SEValidationTarget.cpp
  cdm/io/protobuf/PBActionEnums.cpp
  cdm/io/protobuf/PBActions.cpp
  cdm/io/protobuf/PBAnesthesiaMachine.cpp
  cdm/io/protobuf/PBAnesthesiaMachineEnums.cpp
  cdm/io/protobuf/PBBagValveMask.cpp
  cdm/io/protobuf/PBBagValveMaskEnums.cpp
  cdm/io/protobuf/PBBlackBox.cpp
  cdm/io/protobuf/PBCircuit.cpp
  cdm/io/protobuf/PBCompartment.cpp
  cdm/io/protobuf/PBCompartmentEnums.cpp
  cdm/io/protobuf/PBConditions.cpp
  cdm/io/protobuf/PBECMO.cpp
  cdm/io/protobuf/PBElectroCardioGram.cpp
  cdm/io/protobuf/PBElectroCardioGramEnums.cpp
  cdm/io/protobuf/PBEngine.cpp
  cdm/io/protobuf/PBEngineEnums.cpp
  cdm/io/protobuf/PBEnums.cpp
  cdm/io/protobuf/PBEnvironment.cpp
  cdm/io/protobuf/PBEnvironmentActions.cpp
  cdm/io/protobuf/PBEnvironmentConditions.cpp
  cdm/io/protobuf/PBEnvironmentEnums.cpp
  cdm/io/protobuf/PBEquipmentActions.cpp
  cdm/io/protobuf/PBEvents.cpp
  cdm/io/protobuf/PBInhaler.cpp
  cdm/io/protobuf/PBMechanicalVentilator.cpp
  cdm/io/protobuf/PBMechanicalVentilatorEnums.cpp
  cdm/io/protobuf/PBPatient.cpp
  cdm/io/protobuf/PBPatientActionEnums.cpp
  cdm/io/protobuf/PBPatientActions.cpp
  cdm/io/protobuf/PBPatientAssessmentEnums.cpp
  cdm/io/protobuf/PBPatientAssessments.cpp
  cdm/io/protobuf/PBPatientConditions.cpp
  cdm/io/protobuf/PBPatientEnums.cpp
  cdm/io/protobuf/PBPatientNutrition.cpp
  cdm/io/protobuf/PBPhysiology.cpp
  cdm/io/protobuf/PBPhysiologyEnums.cpp
  cdm/io/protobuf/PBProperties.cpp
  cdm/io/protobuf/PBScenario.cpp
  cdm/io/protobuf/PBSubstance.cpp
  cdm/io/protobuf/PBSubstanceEnums.cpp
  cdm/io/protobuf/PBSubstanceQuantity.cpp
  cdm/io/protobuf/PBTestReport.cpp
  cdm/io/protobuf/PBUtils.cpp
  cdm/io/protobuf/PBValidation.cpp
  cdm/patient/SEMeal.cpp
  cdm/patient/SENutrition.cpp
  cdm/patient/SEPatient.cpp
  cdm/patient/actions/SEAcuteRespiratoryDistressSyndromeExacerbation.cpp
  cdm/patient/actions/SEAcuteStress.cpp
  cdm/patient/actions/SEAirwayObstruction.cpp
  cdm/patient/actions/SEArrhythmia.cpp
  cdm/patient/actions/SEAsthmaAttack.cpp
  cdm/patient/actions/SEBrainInjury.cpp
  cdm/patient/actions/SEBronchoconstriction.cpp
  cdm/patient/actions/SECardiovascularMechanicsModification.cpp
  cdm/patient/actions/SEChestCompression.cpp
  cdm/patient/actions/SEChestCompressionAutomated.cpp
  cdm/patient/actions/SEChestCompressionInstantaneous.cpp
  cdm/patient/actions/SEChestOcclusiveDressing.cpp
  cdm/patient/actions/SEChronicObstructivePulmonaryDiseaseExacerbation.cpp
  cdm/patient/actions/SEConsciousRespiration.cpp
  cdm/patient/actions/SEConsciousRespirationCommand.cpp
  cdm/patient/actions/SEConsumeNutrients.cpp
  cdm/patient/actions/SEDyspnea.cpp
  cdm/patient/actions/SEExercise.cpp
  cdm/patient/actions/SEForcedExhale.cpp
  cdm/patient/actions/SEForcedInhale.cpp
  cdm/patient/actions/SEForcedPause.cpp
  cdm/patient/actions/SEHemorrhage.cpp
  cdm/patient/actions/SEHemothorax.cpp
  cdm/patient/actions/SEImpairedAlveolarExchangeExacerbation.cpp
  cdm/patient/actions/SEIntubation.cpp
  cdm/patient/actions/SEMechanicalVentilation.cpp
  cdm/patient/actions/SENeedleDecompression.cpp
  cdm/patient/actions/SEPatientAction.cpp
  cdm/patient/actions/SEPatientAssessmentRequest.cpp
  cdm/patient/actions/SEPericardialEffusion.cpp
  cdm/patient/actions/SEPneumoniaExacerbation.cpp
  cdm/patient/actions/SEPulmonaryShuntExacerbation.cpp
  cdm/patient/actions/SERespiratoryFatigue.cpp
  cdm/patient/actions/SERespiratoryMechanicsConfiguration.cpp
  cdm/patient/actions/SERespiratoryMechanicsModification.cpp
  cdm/patient/actions/SESubstanceAdministration.cpp
  cdm/patient/actions/SESubstanceBolus.cpp
  cdm/patient/actions/SESubstanceCompoundInfusion.cpp
  cdm/patient/actions/SESubstanceInfusion.cpp
  cdm/patient/actions/SESupplementalOxygen.cpp
  cdm/patient/actions/SETensionPneumothorax.cpp
  cdm/patient/actions/SETubeThoracostomy.cpp
  cdm/patient/actions/SEUrinate.cpp
  cdm/patient/actions/SEUseInhaler.cpp
  cdm/patient/assessments/SEArterialBloodGasTest.cpp
  cdm/patient/assessments/SECompleteBloodCount.cpp
  cdm/patient/assessments/SEComprehensiveMetabolicPanel.cpp
  cdm/patient/assessments/SEPatientAssessment.cpp
  cdm/patient/assessments/SEUrinalysis.cpp
  cdm/patient/assessments/SEUrinalysisMicroscopic.cpp
  cdm/patient/conditions/SEAcuteRespiratoryDistressSyndrome.cpp
  cdm/patient/conditions/SEChronicAnemia.cpp
  cdm/patient/conditions/SEChronicObstructivePulmonaryDisease.cpp
  cdm/patient/conditions/SEChronicPericardialEffusion.cpp
  cdm/patient/conditions/SEChronicRenalStenosis.cpp
  cdm/patient/conditions/SEChronicVentricularSystolicDysfunction.cpp
  cdm/patient/conditions/SEConsumeMeal.cpp
  cdm/patient/conditions/SEDehydration.cpp
  cdm/patient/conditions/SEImpairedAlveolarExchange.cpp
  cdm/patient/conditions/SEPatientCondition.cpp
  cdm/patient/conditions/SEPneumonia.cpp
  cdm/patient/conditions/SEPulmonaryFibrosis.cpp
  cdm/patient/conditions/SEPulmonaryShunt.cpp
  cdm/patient/conditions/SESepsis.cpp
  cdm/properties/SEArray.cpp
  cdm/properties/SEArrayElectricPotential.cpp
  #cdm/properties/SEArrayPressure.cpp
  #cdm/properties/SEArrayVolume.cpp
  #cdm/properties/SEArrayVolumePerTime.cppcpp
  cdm/properties/SECurve.cpp
  cdm/properties/SEFunction.cpp
  cdm/properties/SEFunctionElectricPotentialVsTime.cpp
  cdm/properties/SEFunctionVolumeVsTime.cpp
  cdm/properties/SEHistogram.cpp
  cdm/properties/SEHistogramFractionVsLength.cpp
  cdm/properties/SEProperty.cpp
  cdm/properties/SERunningAverage.cpp
  cdm/properties/SESegment.cpp
  cdm/properties/SESegmentConstant.cpp
  cdm/properties/SESegmentLinear.cpp
  cdm/properties/SESegmentParabolic.cpp
  cdm/properties/SESegmentSigmoidal.cpp
  cdm/properties/SEScalar.cpp
  cdm/properties/SEScalar0To1.cpp
  cdm/properties/SEScalarAmount.cpp
  cdm/properties/SEScalarAmountPerMass.cpp
  cdm/properties/SEScalarAmountPerTime.cpp
  cdm/properties/SEScalarAmountPerVolume.cpp
  cdm/properties/SEScalarArea.cpp
  cdm/properties/SEScalarAreaPerTimePressure.cpp
  cdm/properties/SEScalarElectricCapacitance.cpp
  cdm/properties/SEScalarElectricCharge.cpp
  cdm/properties/SEScalarElectricCurrent.cpp
  cdm/properties/SEScalarElectricInductance.cpp
  cdm/properties/SEScalarElectricPotential.cpp
  cdm/properties/SEScalarElectricResistance.cpp
  cdm/properties/SEScalarEnergy.cpp
  cdm/properties/SEScalarEnergyPerAmount.cpp
  cdm/properties/SEScalarEnergyPerMass.cpp
  cdm/properties/SEScalarEquivalentWeightPerVolume.cpp
  cdm/properties/SEScalarForce.cpp
  cdm/properties/SEScalarFrequency.cpp
  cdm/properties/SEScalarHeatCapacitance.cpp
  cdm/properties/SEScalarHeatCapacitancePerAmount.cpp
  cdm/properties/SEScalarHeatCapacitancePerMass.cpp
  cdm/properties/SEScalarHeatConductance.cpp
  cdm/properties/SEScalarHeatConductancePerArea.cpp
  cdm/properties/SEScalarHeatInductance.cpp
  cdm/properties/SEScalarHeatResistance.cpp
  cdm/properties/SEScalarHeatResistanceArea.cpp
  cdm/properties/SEScalarInversePressure.cpp
  cdm/properties/SEScalarInverseVolume.cpp
  cdm/properties/SEScalarLength.cpp
  cdm/properties/SEScalarLengthPerTime.cpp
  cdm/properties/SEScalarLengthPerTimePressure.cpp
  cdm/properties/SEScalarMass.cpp
  cdm/properties/SEScalarMassPerAmount.cpp
  cdm/properties/SEScalarMassPerAreaTime.cpp
  cdm/properties/SEScalarMassPerMass.cpp
  cdm/properties/SEScalarMassPerTime.cpp
  cdm/properties/SEScalarMassPerVolume.cpp
  cdm/properties/SEScalarNegative1To1.cpp
  cdm/properties/SEScalarOsmolality.cpp
  cdm/properties/SEScalarOsmolarity.cpp
  cdm/properties/SEScalarPower.cpp
  cdm/properties/SEScalarPowerPerAreaTemperatureToTheFourth.cpp
  cdm/properties/SEScalarPressure.cpp
  cdm/properties/SEScalarPressurePerVolume.cpp
  cdm/properties/SEScalarPressureTimePerArea.cpp
  cdm/properties/SEScalarPressureTimePerVolume.cpp
  cdm/properties/SEScalarPressureTimePerVolumeArea.cpp
  cdm/properties/SEScalarPressureTimeSquaredPerVolume.cpp
  cdm/properties/SEScalarTemperature.cpp
  cdm/properties/SEScalarTime.cpp
  cdm/properties/SEScalarUnsigned.cpp
  cdm/properties/SEScalarVolume.cpp
  cdm/properties/SEScalarVolumePerPressure.cpp
  cdm/properties/SEScalarVolumePerTime.cpp
  cdm/properties/SEScalarVolumePerTimeArea.cpp
  cdm/properties/SEScalarVolumePerTimeMass.cpp
  cdm/properties/SEScalarVolumePerTimePressure.cpp
  cdm/properties/SEScalarVolumePerTimePressureArea.cpp
  cdm/properties/SETemporalInterpolator.cpp
  cdm/scenario/SEScenario.cpp
  cdm/scenario/SEScenarioExec.cpp
  cdm/scenario/SEScenarioLog.cpp
  cdm/scenario/SEScenarioLogLegacy.cpp
  cdm/substance/SESubstance.cpp
  cdm/substance/SESubstanceAerosolization.cpp
  cdm/substance/SESubstanceClearance.cpp
  cdm/substance/SESubstanceCompound.cpp
  cdm/substance/SESubstanceConcentration.cpp
  cdm/substance/SESubstanceFraction.cpp
  cdm/substance/SESubstanceManager.cpp
  cdm/substance/SESubstancePharmacodynamics.cpp
  cdm/substance/SESubstancePharmacokinetics.cpp
  cdm/substance/SESubstancePhysicochemicals.cpp
  cdm/substance/SESubstanceTissuePharmacokinetics.cpp
  cdm/substance/SESubstanceTransport.cpp
  cdm/system/SESystem.cpp
  cdm/system/environment/SEActiveConditioning.cpp
  cdm/system/environment/SEAppliedTemperature.cpp
  cdm/system/environment/SEEnvironment.cpp
  cdm/system/environment/SEEnvironmentalConditions.cpp
  cdm/system/environment/actions/SEChangeEnvironmentalConditions.cpp
  cdm/system/environment/actions/SEEnvironmentAction.cpp
  cdm/system/environment/actions/SEThermalApplication.cpp
  cdm/system/environment/conditions/SEEnvironmentCondition.cpp
  cdm/system/environment/conditions/SEInitialEnvironmentalConditions.cpp
  cdm/system/equipment/SEEquipment.cpp
  cdm/system/equipment/SEEquipmentAction.cpp
  cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachine.cpp
  cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachineChamber.cpp
  cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachineOxygenBottle.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineAction.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineConfiguration.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineExpiratoryValveLeak.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineExpiratoryValveObstruction.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineInspiratoryValveLeak.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineInspiratoryValveObstruction.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineMaskLeak.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineOxygenTankPressureLoss.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineOxygenWallPortPressureLoss.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineSodaLimeFailure.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineTubeCuffLeak.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineVaporizerFailure.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineVentilatorPressureLoss.cpp
  cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineYPieceDisconnect.cpp
  cdm/system/equipment/bag_valve_mask/SEBagValveMask.cpp
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskAction.cpp
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskAutomated.cpp
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskConfiguration.cpp
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskInstantaneous.cpp
  cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskSqueeze.cpp
  cdm/system/equipment/ecmo/SEECMO.cpp
  cdm/system/equipment/ecmo/SEECMOSettings.cpp
  cdm/system/equipment/ecmo/actions/SEECMOAction.cpp
  cdm/system/equipment/ecmo/actions/SEECMOConfiguration.cpp
  cdm/system/equipment/electrocardiogram/SEElectroCardioGram.cpp
  cdm/system/equipment/electrocardiogram/SEElectroCardioGramWaveform.cpp
  cdm/system/equipment/inhaler/SEInhaler.cpp
  cdm/system/equipment/inhaler/actions/SEInhalerAction.cpp
  cdm/system/equipment/inhaler/actions/SEInhalerConfiguration.cpp
  cdm/system/equipment/mechanical_ventilator/SEMechanicalVentilator.cpp
  cdm/system/equipment/mechanical_ventilator/SEMechanicalVentilatorSettings.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorAction.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorConfiguration.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorContinuousPositiveAirwayPressure.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorHold.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorLeak.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorMode.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorPressureControl.cpp
  cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorVolumeControl.cpp
  cdm/system/physiology/SEBloodChemistrySystem.cpp
  cdm/system/physiology/SECardiovascularMechanicsModifiers.cpp
  cdm/system/physiology/SECardiovascularSystem.cpp
  cdm/system/physiology/SEDrugSystem.cpp
  cdm/system/physiology/SEEndocrineSystem.cpp
  cdm/system/physiology/SEEnergySystem.cpp
  cdm/system/physiology/SEGastrointestinalSystem.cpp
  cdm/system/physiology/SEHepaticSystem.cpp
  cdm/system/physiology/SENervousSystem.cpp
  cdm/system/physiology/SEPupillaryResponse.cpp
  cdm/system/physiology/SERenalSystem.cpp
  cdm/system/physiology/SERespiratoryMechanics.cpp
  cdm/system/physiology/SERespiratoryMechanicsModifiers.cpp
  cdm/system/physiology/SERespiratorySystem.cpp
  cdm/system/physiology/SETissueSystem.cpp
  cdm/utils/ConfigParser.cpp
  cdm/utils/CSV.cpp
  cdm/utils/DataPeak.cpp
  cdm/utils/DataTrack.cpp
  cdm/utils/FileUtils.cpp
  cdm/utils/GeneralMath.cpp
  cdm/utils/Logger.cpp
  cdm/utils/ParameterIteration.cpp
  cdm/utils/ScopedMutex.cpp
  cdm/utils/SimpleLogger.cpp
  cdm/utils/TimingProfile.cpp
  cdm/utils/base64.cpp
  cdm/utils/testing/SETestCase.cpp
  cdm/utils/testing/SETestErrorStatistics.cpp
  cdm/utils/testing/SETestManager.cpp
  cdm/utils/testing/SETestReport.cpp
  cdm/utils/testing/SETestSuite.cpp
  cdm/utils/unitconversion/CompoundUnit.cpp
  cdm/utils/unitconversion/CompoundUnitElement.cpp
  cdm/utils/unitconversion/PScalar.cpp
  cdm/utils/unitconversion/PrefixDescriptor.cpp
  cdm/utils/unitconversion/QuantityConversionDescriptor.cpp
  cdm/utils/unitconversion/QuantityConversionKey.cpp
  cdm/utils/unitconversion/QuantityTypeDescriptor.cpp
  cdm/utils/unitconversion/UCEDefs.cpp
  cdm/utils/unitconversion/UnitConversionEngine.cpp
  cdm/utils/unitconversion/UnitDescriptor.cpp
  cdm/utils/unitconversion/UnitDimension.cpp
  cdm/utils/unitconversion/UnitStringLexer.cpp
)
set(CDM_H_FILES ${BINDING_H_FILES} PARENT_SCOPE)
set(CDM_CPP_FILES ${BINDING_CPP_FILES} PARENT_SCOPE)

set(CDM_TEST_H_FILES
  cdm/test/CommonDataModelTest.h
)
set(CDM_TEST_CPP_FILES
  cdm/test/ActionTest.cpp
  cdm/test/AdvancedCircuitTest.cpp
  cdm/test/BasicCircuitTest.cpp
  cdm/test/BlackBoxTest.cpp
  cdm/test/CommonDataModelTest.cpp
  cdm/test/ConvertScenarioLogs.cpp
  cdm/test/GasCompartmentTest.cpp
  cdm/test/LiquidCompartmentTest.cpp
  cdm/test/ReadPatientDirectory.cpp
  cdm/test/ReadSubstanceDirectory.cpp
  cdm/test/ScalarTest.cpp
  cdm/test/SubstanceTransport.cpp
  cdm/test/ThermalCompartmentTest.cpp
  cdm/test/TissueCompartmentTest.cpp
  cdm/test/UnitsTest.cpp
  cdm/test/WaveformInterpolatorTest.cpp
)
set(CDM_TEST_H_FILES ${CDM_TEST_H_FILES} PARENT_SCOPE)
set(CDM_TEST_CPP_FILES ${CDM_TEST_CPP_FILES} PARENT_SCOPE)
