/* Distributed under the Apache License, Version 2.0.
   See accompanying NOTICE file for details.*/

#include "cdm/CommonDefs.h"
#include "cdm/patient/actions/SEConsciousRespirationCommand.h"

SEConsciousRespirationCommand::SEConsciousRespirationCommand(Logger* logger) : Loggable(logger)
{
  m_Comment = "";
}

SEConsciousRespirationCommand::~SEConsciousRespirationCommand()
{
  m_Comment = "";
}

void SEConsciousRespirationCommand::Clear()
{
  m_Comment = "";
}

bool SEConsciousRespirationCommand::IsValid() const
{
  return true;
}

bool SEConsciousRespirationCommand::IsActive() const
{
  return true;
}

std::string SEConsciousRespirationCommand::GetComment() const
{
  return m_Comment;
}
void SEConsciousRespirationCommand::SetComment(const std::string& comment)
{
  m_Comment = comment;
}
bool SEConsciousRespirationCommand::HasComment() const
{
  return m_Comment.empty() ? false : true;
}
void SEConsciousRespirationCommand::InvalidateComment()
{
  m_Comment = "";
}


