# I used this command in windows cmd: dir /a-D /S /B

set(PULSE_CSHARP_BIND_DIR "${CMAKE_BINARY_DIR}/src/csharp")
set(PULSE_CSHARP_BIND_FILES
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Actions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/AnesthesiaMachine.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/AnesthesiaMachineActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/BagValveMask.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/BagValveMaskActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/BlackBox.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Circuit.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Compartment.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Conditions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/ECMO.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/ECMOActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/ElectroCardioGram.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Engine.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Enums.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Environment.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/EnvironmentActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/EnvironmentConditions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/EquipmentActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Events.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Inhaler.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/InhalerActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/MechanicalVentilator.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/MechanicalVentilatorActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Patient.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/PatientActions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/PatientAssessments.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/PatientConditions.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/PatientNutrition.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Physiology.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Plots.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Properties.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Scenario.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/Substance.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/SubstanceQuantity.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/cdm/bind/TestReport.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/engine/bind/Configuration.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/engine/bind/Enums.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/engine/bind/Environment.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/engine/bind/Equipment.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/engine/bind/Physiology.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/engine/bind/Scenario.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/engine/bind/State.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/study/bind/hydrocephalus/Hydrocephalus.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/study/bind/multiplex_ventilation/MultiplexVentilation.cs
  ${PULSE_CSHARP_BIND_DIR}/pulse/study/bind/sensitivity_analysis/SensitivityAnalysis.cs
)

set(PULSE_CSHARP_HOWTO_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_CreateState.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_DeathState.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_Dehydration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_EngineUse.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_Environment.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_ECMO.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_Hemorrhage.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_Hemothorax.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_MechanicalVentilator.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_PatientStates.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_SystemModifiers.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_RespiratoryMechanics.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_RunScenarios.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_VentilationMechanics.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/HowTo_UseStates.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/howto/Program.cs
)

set(PULSE_CSHARP_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/AssemblyInfo.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/CommonDataModel.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEActionManager.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEAdvanceTime.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEAdvanceUntilStable.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SECondition.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEConditionManager.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEDataRequest.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEDataRequestManager.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEEnvironmentActionCollection.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEEquipmentActionCollection.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEEvents.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SELogger.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEPatientActionCollection.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SEPatientConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SESerializeRequested.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/engine/SESerializeState.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBActions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBAnesthesiaMachine.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBBagValveMask.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBConditions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBDataRequest.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBECMO.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBEnums.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBEnvironment.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBEnvironmentActions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBEnvironmentConditions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBEquipmentActions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBEvents.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBInhaler.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBLogMessages.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBMechanicalVentilator.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBNutrition.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBPatient.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBPatientActions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBPatientAssessmets.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBPatientConditions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBPatientConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBPhysiology.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBProperties.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/io/PBScenario.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/SENutrition.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/SEPatient.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEAcuteRespiratoryDistressSyndromeExacerbation.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEAcuteStress.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEAirwayObstruction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEArrhythmia.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEAsthmaAttack.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEBrainInjury.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEBronchoconstriction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SECardiovascularMechanicsModification.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEChestCompression.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEChestCompressionAutomated.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEChestCompressionInstantaneous.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEChestOcclusiveDressing.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEChronicObstructivePulmonaryDiseaseExacerbation.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEConsciousRespiration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEConsumeNutrients.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEDyspnea.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEExercise.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEHemorrhage.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEHemothorax.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEImpairedAlveolarExchangeExacerbation.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEIntubation.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEMechanicalVentilation.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SENeedleDecompression.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEPatientAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEPericardialEffusion.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEPneumoniaExacerbation.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEPulmonaryShuntExacerbation.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SERespiratoryFatigue.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SERespiratoryMechanicsConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SERespiratoryMechanicsModification.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SESubstanceBolus.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SESubstanceCompoundInfusion.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SESubstanceInfusion.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SESupplementalOxygen.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SETensionPneumothorax.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SETubeThoracostomy.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/actions/SEUrinate.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/assessments/SEArterialBloodGasTest.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/assessments/SECompleteBloodCount.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/assessments/SEComprehensiveMetabolicPanel.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/assessments/SEPatientAssessment.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/assessments/SEUrinalysis.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/assessments/SEUrinalysisMicroscopic.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEAcuteRespiratoryDistressSyndrome.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEChronicAnemia.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEChronicHeartFailure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEChronicObstructivePulmonaryDisease.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEChronicPericardialEffusion.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEChronicRenalStenosis.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEChronicVentricularSystolicDysfunction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEDehydration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEImpairedAlveolarExchange.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEPatientCondition.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEPneumonia.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEPulmonaryFibrosis.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SEPulmonaryShunt.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/patient/conditions/SESepsis.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SECurve.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEProperty.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalar.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalar0To1.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarAmount.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarAmountPerVolume.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarArea.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarElectricPotential.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarEquivalentWeightPerVolume.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarForce.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarFrequency.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarHeatConductancePerArea.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarHeatResistanceArea.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarInversePressure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarLength.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarLengthPerTime.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarMass.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarMassPerAmount.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarMassPerAreaTime.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarMassPerTime.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarMassPerVolume.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarNegative1To1.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarPower.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarPressure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarPressurePerVolume.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarPressureTimePerVolume.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarTemperature.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarTime.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarUnsigned.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarVolume.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarVolumePerPressure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarVolumePerTime.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarVolumePerTimeMass.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SEScalarVolumePerTimePressure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SESegment.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SESegmentConstant.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SESegmentLinear.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SESegmentParabolic.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/properties/SESegmentSigmoidal.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/scenario/SEScenario.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/scenario/SEScenarioExec.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/substance/SESubstanceConcentration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/substance/SESubstanceFraction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/SESystem.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/SEActiveConditioning.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/SEAppliedTemperature.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/SEEnvironmentalConditions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/actions/SEChangeEnvironmentalConditions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/actions/SEEnvironmentAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/actions/SEThermalApplication.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/conditions/SEEnvironmentCondition.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/environment/conditions/SEInitialEnvironmentalConditions.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/SEEquipment.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/SEEquipmentAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachine.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachineChamber.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/SEAnesthesiaMachineOxygenBottle.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineExpiratoryValveLeak.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineExpiratoryValveObstruction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineInspiratoryValveLeak.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineInspiratoryValveObstruction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineMaskLeak.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineOxygenTankPressureLoss.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineOxygenWallPortPressureLoss.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineSodaLimeFailure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineTubeCuffLeak.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineVaporizerFailure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineVentilatorPressureLoss.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/anesthesia_machine/actions/SEAnesthesiaMachineYPieceDisconnect.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/bag_valve_mask/SEBagValveMask.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskAutomated.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskInstantaneous.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/bag_valve_mask/actions/SEBagValveMaskSqueeze.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/ecmo/SEECMOSettings.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/ecmo/actions/SEECMOAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/ecmo/actions/SEECMOConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/inhaler/SEInhaler.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/inhaler/actions/SEInhalerAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/inhaler/actions/SEInhalerConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/SEMechanicalVentilatorSettings.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorAction.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorContinuousPositiveAirwayPressure.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorHold.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorLeak.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorMode.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorPressureControl.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/equipment/mechanical_ventilator/actions/SEMechanicalVentilatorVolumeControl.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/physiology/SECardiovascularMechanicsModifiers.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/physiology/SERespiratoryMechanics.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/physiology/SERespiratoryMechanicsModifiers.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/system/physiology/SERespiratorySystem.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/utils/Logger.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/utils/RunConfiguration.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/cdm/utils/UnitConverter.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/engine/PulseEngine.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/engine/PulseScenarioExec.cs
  ${CMAKE_CURRENT_SOURCE_DIR}/pulse/engine/io/PBScenario.cs
  )